<?php
namespace Geral\Entities;

use Setforms2\Shared\Registry;

class Nutriente extends Base\Nutriente
{


    public function atualizaGrupo($grupo, $data, $oper, $nrorg){
        $this->setCdgrupnutr($grupo);

        $this->setDtultatu($data);
        $this->setCdoperultatu($oper);
        $this->setNrorgultatu($nrorg);

        $this->persist();
    }



    public static function insereNutriente($nrorg, $data, $cdnutriente, $nmnutriente, $nmreduzido, $idtiponutr, $sgunidade, $cdgrupnutr,
                                    $cdoper, $idativo, $idcalorias, $idnutrrelev, $vrfatornutr, $idkcal, $nrordemnutr)
    {
        $con = Registry::getEntityManager();
        $con->beginTransaction();

        /** @var \Geral\Entities\Nutriente $obj_Nutriente */
        $obj_Nutriente = new Nutriente();

        $obj_Nutriente->setCdnutriente($cdnutriente);
        $obj_Nutriente->setNmnutriente($nmnutriente);
        $obj_Nutriente->setNmreduzido($nmreduzido);
        $obj_Nutriente->setIdtiponutr($idtiponutr);
        $obj_Nutriente->setSgunidade($sgunidade);
        $obj_Nutriente->setCdgrupnutr($cdgrupnutr);
        $obj_Nutriente->setDtultatunutr($data);
        $obj_Nutriente->setNrorg($nrorg);
        $obj_Nutriente->setDtinclusao($data);
        $obj_Nutriente->setDtultatu($data);
        $obj_Nutriente->setNrorginclusao($nrorg);
        $obj_Nutriente->setCdoperinclusao($cdoper);
        $obj_Nutriente->setNrorgultatu($nrorg);
        $obj_Nutriente->setCdoperultatu($cdoper);
        $obj_Nutriente->setIdativo($idativo);
        $obj_Nutriente->setIdcalorias($idcalorias);
        $obj_Nutriente->setIdnutrrelev($idnutrrelev);
        $obj_Nutriente->setVrfatornutr($vrfatornutr);
        $obj_Nutriente->setNrordemnutr($nrordemnutr);
        $obj_Nutriente->setIdkcal($idkcal);

        $obj_Nutriente->persist();

        $con->flush();
        $con->commit();
    }


    public static function atualizaNutriente($nrorg, $data, $cdnutriente, $nmnutriente, $nmreduzido, $idtiponutr, $sgunidade, $cdgrupnutr,
                                      $cdoper, $idcalorias, $idnutrrelev, $vrfatornutr, $idkcal, $nrordemnutr)
    {
        $con = Registry::getEntityManager();
        $con->beginTransaction();

        /** @var \Geral\Entities\Nutriente $obj_Nutriente */
        $obj_Nutriente = \Geral\Entities\Nutriente::getObjectByWhere('NRORG = ? AND CDNUTRIENTE = ?', array($nrorg, $cdnutriente));

        $obj_Nutriente->setNmnutriente($nmnutriente);
        $obj_Nutriente->setNmreduzido($nmreduzido);
        $obj_Nutriente->setIdtiponutr($idtiponutr);
        $obj_Nutriente->setSgunidade($sgunidade);
        $obj_Nutriente->setCdgrupnutr($cdgrupnutr);
        $obj_Nutriente->setDtultatunutr($data);
        $obj_Nutriente->setDtultatu($data);
        $obj_Nutriente->setCdoperultatu($cdoper);
        $obj_Nutriente->setIdcalorias($idcalorias);
        $obj_Nutriente->setIdnutrrelev($idnutrrelev);
        $obj_Nutriente->setVrfatornutr($vrfatornutr);
        $obj_Nutriente->setNrordemnutr($nrordemnutr);
        $obj_Nutriente->setIdkcal($idkcal);

        $obj_Nutriente->persist();

        $con->flush();
        $con->commit();
    }


    /**
     * Retorna objeto da classe Nutriente
     * @static
     * @param $cdgrupnutr
     * @param $cdnutriente
     * @return bool
     */
    public static function retornaNutriente($cdgrupnutr, $cdnutriente)
    {
        $obj_Nutriente = self::getObjectByWhere('CDGRUPNUTR = ? AND CDNUTRIENTE = ?',
            array($cdgrupnutr, $cdnutriente)
        );
        return $obj_Nutriente;
    }

    /**
     * Cria um novo Nutriente, mas não o insere no banco imediatamente.
     *
     * @param String $nrorg         Organização
     * @param String $data          Data
     * @param String $cdnutriente   Código Nutriente
     * @param String $nmnutriente   Nome Nutriente
     * @param String $nmreduzido    Nome Reduzido
     * @param String $idtiponutr    Tipo Nutriente
     * @param String $sgunidade     Unidade
     * @param String $cdgrupnutr    Grupo Nutriente
     * @param String $cdoper        Operador
     * @param String $idativo       Ativo
     * @param String $idcalorias    Calorias
     * @param String $idnutrrelev   Nutrrelev
     * @param String $vrfatornutr   Fatornutr
     * @param String $idkcal        Kcal
     * @param String $nrordemnutr   Ordem Nutriente
     * @param self   $obj_Nutriente Nutriente
     *
     * @return null
     */
    public static function novoNutriente(
        $nrorg, $data, $cdnutriente, $nmnutriente, $nmreduzido, $idtiponutr,
        $sgunidade, $cdgrupnutr, $cdoper, $idativo, $idcalorias, $idnutrrelev,
        $vrfatornutr, $idkcal, $nrordemnutr, $obj_Nutriente = null
    ) {

        if (($obj_Nutriente == null) || ($obj_Nutriente === false)) {
            /**
             * Novo Objeto Nutriente
             * @var \Geral\Entities\Nutriente $obj_Nutriente
             */
            $obj_Nutriente = new Nutriente();
        } else {
            if (!$obj_Nutriente instanceof self) {
                return null;
            }
        }


        $obj_Nutriente->setCdnutriente($cdnutriente);
        $obj_Nutriente->setNmnutriente($nmnutriente);
        $obj_Nutriente->setNmreduzido($nmreduzido);
        $obj_Nutriente->setIdtiponutr($idtiponutr);
        $obj_Nutriente->setSgunidade($sgunidade);
        $obj_Nutriente->setCdgrupnutr($cdgrupnutr);
        $obj_Nutriente->setDtultatunutr($data);
        $obj_Nutriente->setNrorg($nrorg);
        $obj_Nutriente->setDtinclusao($data);
        $obj_Nutriente->setDtultatu($data);
        $obj_Nutriente->setNrorginclusao($nrorg);
        $obj_Nutriente->setCdoperinclusao($cdoper);
        $obj_Nutriente->setNrorgultatu($nrorg);
        $obj_Nutriente->setCdoperultatu($cdoper);
        $obj_Nutriente->setIdativo($idativo);
        $obj_Nutriente->setIdcalorias($idcalorias);
        $obj_Nutriente->setIdnutrrelev($idnutrrelev);
        $obj_Nutriente->setVrfatornutr($vrfatornutr);
        $obj_Nutriente->setNrordemnutr($nrordemnutr);
        $obj_Nutriente->setIdkcal($idkcal);

        $obj_Nutriente->persist();
    }
}