/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPODEBITO                                               */
/* Tabela : TPDEBIBANC                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 25/11/2006 Adalberto Teodoro Oliveira                                      */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPODEBITO
BEFORE INSERT OR UPDATE OR DELETE
ON TPDEBIBANC FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPDB := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTPDEBIBANC,'') <> NVL(:NEW.CDTPDEBIBANC,'')) OR
         (NVL(:OLD.CDCLASSFINA, '') <> NVL(:NEW.CDCLASSFINA, '')) OR
         (NVL(:OLD.CDHISTPADR,  '') <> NVL(:NEW.CDHISTPADR,  '')) OR
         (NVL(:OLD.CDCONTCTBL,  '') <> NVL(:NEW.CDCONTCTBL,  '')) OR
         (NVL(:OLD.DSTPDEBIBANC,'') <> NVL(:NEW.DSTPDEBIBANC,'')) OR
         (NVL(:OLD.IDCTBLDBBANC,'') <> NVL(:NEW.IDCTBLDBBANC,'')) THEN
         :NEW.DTULTATUTPDB := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TPDEBIBANC', '', 'CDTPDEBIBANC='||:OLD.CDTPDEBIBANC||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TPDEBIBANC MODIFY DTULTATUTPDB DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPODEBITO','4.09.095'); END;
/

